// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// GSBlobDlg.cpp : Cve[V t@C
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGSBlobDlg _CAO

CGSBlobDlg::CGSBlobDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGSBlobDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGSBlobDlg)
	m_searchmode = -1;
	m_precision = -1;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_gswndtouch = FALSE;
	m_binlevel = 128;
	m_maxsize = 245760;
	m_minsize = 5;
	m_color = -1;
	m_arrange = -1;
	m_blobwndtouch = FALSE;
	m_result = _T("");
	m_disp = NULL;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGSBlobDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGSBlobDlg)
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxInt(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxInt(pDX, m_middlethreshold, 10, 99);
	DDX_Check(pDX, IDC_GSWNDTOUCH, m_gswndtouch);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_MAXSIZE, m_maxsize);
	DDX_Text(pDX, IDC_MINSIZE, m_minsize);
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_CBIndex(pDX, IDC_ARRANGE, m_arrange);
	DDX_Check(pDX, IDC_BLOBWNDTOUCH, m_blobwndtouch);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGSBlobDlg, CDialog)
	//{{AFX_MSG_MAP(CGSBlobDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DISPBIN, OnDispbin)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_BLOBEXEREGION, OnBlobexeregion)
	ON_BN_CLICKED(IDC_SETPATTERN, OnSetpattern)
	ON_BN_CLICKED(IDC_DISPPATTERN, OnDisppattern)
	ON_BN_CLICKED(IDC_SETPATTERNMASK, OnSetpatternmask)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_LOADPATTERN, OnLoadpattern)
	ON_BN_CLICKED(IDC_SAVEPATTERN, OnSavepattern)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_SETSTANDARD, OnSetstandard)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_DOSAMPLE, OnDosample)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGSBlobDlg bZ[W nh

BOOL CGSBlobDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		long err_no ;

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxBlob.CreateInstance( __uuidof( FvxBlob ) ); 
		m_FvxROI1.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxROI2.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) ); 
		m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) ); 
		m_pBlobExeRect.CreateInstance( __uuidof( FvRectangle ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 
		m_pStandardPoint.CreateInstance( __uuidof( FvPoint ) ); 

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// fBXvC
	    m_disp = new CDisplay();
		m_disp->Create( IDD_DISPLAY , GetDesktopWindow() );
		m_disp->ShowWindow( SW_HIDE );

		// fBXvC̏
		m_disp->m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_pBlobExeRect->Putxs( 100 );
		m_pBlobExeRect->Putxe( 200 );
		m_pBlobExeRect->Putys( 100 );
		m_pBlobExeRect->Putye( 200 );

		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );
		
		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
		pcmb->AddString( "ʏ̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "sp^[" );
		m_searchmode = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
		pcmb->AddString( "ʏ퐸x" );
		pcmb->AddString( "x" );
		pcmb->AddString( "x" );
		m_precision = 0 ;
		
		pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "BLACK" );
		pcmb->AddString( "WHITE" );
		m_color = 1;

		pcmb = ( CComboBox* )GetDlgItem( IDC_ARRANGE );
		pcmb->AddString( "UP_TO_LEFT_RIGHT" );
		pcmb->AddString( "UP_TO_RIGHT_LEFT" );
		pcmb->AddString( "DOWN_TO_LEFT_RIGHT" );
		pcmb->AddString( "DOWN_TO_RIGH_LEFT" );
		pcmb->AddString( "LEFT_TO_UP_DOWN" );
		pcmb->AddString( "LEFT_TO_DOWN_UP" );
		pcmb->AddString( "RIGHT_TO_UP_DOWN" );
		pcmb->AddString( "RIGHT_TO_DOWN_UP" );
		m_arrange = 0 ;
		UpdateData(FALSE); 
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {

			// rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage1 );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CGSBlobDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CGSBlobDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// fBXvC\
		m_disp->ShowWindow( SW_SHOW );
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CGSBlobDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// ʏI
void CGSBlobDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// DisplayJ
	if ( m_disp!=NULL ) {
		m_disp->DestroyWindow();
		delete m_disp;
		m_disp = NULL;
	}

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}

// Qls
void CGSBlobDlg::OnDispbin() 
{
    
	if ( ! UpdateData(TRUE) ) return ;

	if (( 0 <= m_binlevel ) && ( m_binlevel < 256 )) {
        // Ql
        m_FvxChangeImage->FixedLevel( m_FvxImage1, m_FvxImage2, m_binlevel );
        m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage2 );
    } else {
		MessageBox("Ql臒l0`255͈̔͂œ͂Ă" , "G[" , MB_ICONWARNING | MB_OK );
		return;
	}
		
}

// ͈͂̐ݒ
void CGSBlobDlg::OnExeregion() 
{
    
    m_FvxROI1->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
	m_FvxROI1->PutUsePoint( FALSE );
    m_FvxROI1->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI1->GetCheckRectangle() == 1 )) {
		m_FvxROI1->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
		double dblTemp = 0;
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}
		
}

// Ql͈͐ݒ
void CGSBlobDlg::OnBlobexeregion() 
{
	
    m_FvxROI1->SetRectangle( m_pBlobExeRect );
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
	m_FvxROI1->PutUsePoint( FALSE );
    m_FvxROI1->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI1->GetCheckRectangle() == 1 )) {
        m_FvxROI1->GetRectangle( m_pBlobExeRect );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( m_pBlobExeRect->Getxe() < m_pBlobExeRect->Getxs() ) {
            dblTemp = m_pBlobExeRect->Getxs();
            m_pBlobExeRect->Putxs( m_pBlobExeRect->Getxe() );
            m_pBlobExeRect->Putxe( dblTemp );
		}
		if ( m_pBlobExeRect->Getye() < m_pBlobExeRect->Getys() ) {
            dblTemp = m_pBlobExeRect->Getys();
            m_pBlobExeRect->Putys( m_pBlobExeRect->Getye() );
            m_pBlobExeRect->Putye( dblTemp );
		}
	}
}

// p^[o^
void CGSBlobDlg::OnSetpattern() 
{
    
	IFvRectangle2Ptr pRect( __uuidof( FvRectangle ));    // p^[̈̐ݒ
    IFvPointPtr pPoint( __uuidof( FvPoint ));			 // p^[_
    
    // o^̏`ݒ
    pRect->Putxs( 100 );
    pRect->Putys( 100 );
    pRect->Putxe( 200 );
    pRect->Putye( 200 );
    m_FvxROI2->SetRectangle( pRect );
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
	m_FvxROI2->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI2->GetCheckRectangle() == 1 )) {
		m_FvxROI2->GetRectangle( pRect );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( ( pRect->Getxe()) < ( pRect->Getxs()) ) {
            dblTemp = pRect->Getxs();
            pRect->Putxs(pRect->Getxe()) ;
            pRect->Putxe( dblTemp );
		}
		if (( pRect->Getye()) < ( pRect->Getys() )) {
            dblTemp = pRect->Getys();
            pRect->Putys( pRect->Getye() );
            pRect->Putye( dblTemp );
		}
			
        if ( m_FvxROI2->GetCheckPoint() == 1 ) {
            m_FvxROI2->GetPoint( pPoint );
		} else {
			MessageBox("p^[_w肳܂łB\r\np^[`̒S_Ƃēo^܂" , "p^[o^" , MB_ICONWARNING | MB_OK );
            
            pPoint->Putx( (pRect->Getxs() + pRect->Getxe()) / 2 );
            pPoint->Puty ( (pRect->Getys() + pRect->Getye()) / 2 );
		}
			
        m_FvxPattern->MakePattern( m_FvxImage1, pRect, pPoint );
	}

}

// p^[̕\
void CGSBlobDlg::OnDisppattern() 
{
    m_FvxPattern->Disp(-1,-1);
}

// p^[̃}XNݒ
void CGSBlobDlg::OnSetpatternmask() 
{
	m_FvxPattern->DefMask(-1,-1);
}

// J摜荞
void CGSBlobDlg::OnGrab() 
{
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage1 );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImage1 );
    // 荞񂾉摜ʂɕ\
	m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	
}

// 摜t@CǍ
void CGSBlobDlg::OnLoadimage() 
{	
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage1->GetImageType ()!=imageGray ) || ( m_FvxImage1->GetBitPerPixel()!=8 )) {

			MessageBox("OC摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}
        m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	}
}

// p^[t@C̓Ǎ
void CGSBlobDlg::OnLoadpattern() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    // "pat"gp邱Ƃ𐄏܂

	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern->PutLoadPattrenFileName(_bstr_t( cFileDlg.GetPathName()));
			m_FvxPattern->Load();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[ǍݎsBerr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// p^[t@C̕ۑ
void CGSBlobDlg::OnSavepattern() 
{
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂
	char szFilters[]="bitmap file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {

			m_FvxPattern->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// 摜ۑ
void CGSBlobDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

int CGSBlobDlg::ApplyChanges()
{

	if (!UpdateData(TRUE)) return -1;

    // OCT[` ------------------------------------------------------------
    // p[^ݒ
    m_FvxCorrelation->SetInspectArea( m_ExeRegion );						// ͈
    m_FvxCorrelation->PutSearchMode( (SEARCH_MODE_TYPE )m_searchmode );		// T[`[hiׂȂǂ̃p^[Ɏgpj
    m_FvxCorrelation->PutPrecision( (PRECISION_TYPE)m_precision );			// T[`
    
    // 摜̏
    if (( m_condition < 1 ) || ( m_condition > 9 )) {
		MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}
	m_FvxCorrelation->PutCondition( m_condition );

    // 臒l
    if (( m_threshold < 10 ) || ( m_threshold > 1000 )) {
		MessageBox("臒l 10`100 ̊Ԃœ͂Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}
	m_FvxCorrelation->PutScoreThresh( m_threshold );
    
    // r臒l
	if ( ( m_middlethreshold < 10 ) || ( m_middlethreshold > 1000 )) {
		MessageBox("r臒l 10`100 ̊Ԃœ͂Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}
	m_FvxCorrelation->PutScoreThresh2( m_middlethreshold );
    
    // T[`
    m_FvxCorrelation->PutSearchNum( 1 );
    
    // ͈͐ڐGĂ̂o邩
    if ( m_gswndtouch == TRUE ) {
        m_FvxCorrelation->PutWindowTouch( ON );
	} else {
        m_FvxCorrelation->PutWindowTouch( OFF );
	}

    // Qlʌv ------------------------------------------------------------
    // Ql臒lݒ
    // QlImageFvxImage2ɍ쐬
	if ( (  0 <= m_binlevel ) &&  ( m_binlevel < 256 ) ) {
        m_FvxChangeImage->FixedLevel( m_FvxImage1, m_FvxImage2, m_binlevel );
	} else {
		MessageBox("Ql臒l0`255͈̔͂œ͂Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}
		
    // ŏʐϒl`FbN
    if ( m_minsize < 1 ) {
		MessageBox("ŏʐϒl͂Pȏ̐lݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}
	if ( m_minsize >= m_maxsize ) {
		MessageBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
		return -1;
	}

    // őEŏʐϐݒ
    m_FvxBlob->PutMinSize( m_minsize );
    m_FvxBlob->PutMaxSize( m_maxsize );

    // ΏېFݒ
    if ( m_color == 0 ) {
        m_FvxBlob->PutColor( ( COLOR_TYPE )0 );
	} else {
		m_FvxBlob->PutColor( ( COLOR_TYPE )1 );
	}

    // xOiojݒ
    switch ( m_arrange ) {
	case 0:
		m_FvxBlob->PutArrange( UP_TO_LEFT_RIGHT );
		break;
	case 1:
		m_FvxBlob->PutArrange( UP_TO_RIGHT_LEFT );
		break;
	case 2:
		m_FvxBlob->PutArrange( DOWN_TO_LEFT_RIGHT );
		break;
	case 3:
		m_FvxBlob->PutArrange( DOWN_TO_RIGHT_LEFT );
		break;
	case 4:
		m_FvxBlob->PutArrange( LEFT_TO_UP_DOWN );
		break;
	case 5:
		m_FvxBlob->PutArrange( LEFT_TO_DOWN_UP );
		break;
	case 6:
		m_FvxBlob->PutArrange( RIGHT_TO_UP_DOWN );
		break;
	case 7:
		m_FvxBlob->PutArrange( RIGHT_TO_DOWN_UP );
		break;
	}

    // ͈͐ڐG
    if ( m_blobwndtouch == TRUE ) {
        m_FvxBlob->PutWindowTouch( ON );
	} else {
		m_FvxBlob->PutWindowTouch( OFF );
	}
				
	return 0;
}

// ʒuv
void CGSBlobDlg::OnSetstandard() 
{
    
	long lngCount = 0;

	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
    
    // p[^ݒ
    if ( ApplyChanges() == 0 ) {
    
		try {
        
			// p^[ݒ
			m_FvxCorrelation->SetPattern( m_FvxPattern );
        
			// T[`s
			m_FvxCorrelation->Execute( m_FvxImage1, &lngCount );

		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxCorrelation->GetErrReport( &lngErr );

			switch ( lngErr ) {
			case 0:
				cStr = "G[";
			case 5001:
				cStr = "p^݂Ă܂B";
			case 5005:
				cStr = "p[^Ⴂ܂B";
			case 5006:
				cStr = "^Ⴂ܂B";
			case 5007:
				cStr = "p^摜̂߁Ao^ł܂B";
			case 5008:
				cStr = "p^ƃ}XÑTCYvĂ܂B";
			case 5009:
				cStr = "p[^NULLlw肳܂B";
			case 5010:
				cStr = "̊mۂɎs܂B";
			case 5022:
				cStr = "p^w肳Ă܂B";
			default:
	            cStr = "sȃG[";
			}

			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}

        // ͈͂ŕ\
	    m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
        m_disp->m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
		IFvSearchResultPtr pSearchResult( __uuidof( FvSearchResult ));
		
		if ( lngCount > 0 ) {
            // T[`ʂԂŕ\
            m_FvxCorrelation->GetResult( 0, pSearchResult );
		    m_disp->m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );
            m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult );
            
            // _Ƃēo^
            m_pStandardPoint->Putx( pSearchResult->Getx() );
            m_pStandardPoint->Puty( pSearchResult->Gety() );
        
            m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
            m_disp->m_FvxDisplayEx->DrawData( 0, m_pBlobExeRect ) ; // v͈͂̕\
            
		} else {
			MessageBox("T[`p^܂ł" , "T[`s", MB_ICONWARNING | MB_OK);
			return;
		}
				
	}
}
 
// s
void CGSBlobDlg::OnExecute() 
{
    
    long  lngCount = 0;
	long lngErr = 0;
    CString cResult;

	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    
	// p[^Kp
    if ( ApplyChanges() == 0  ) {
        
        // ------------------------------------------------------------
        // ԑJn
        m_FvxPerformanceCounter->StartCount();
		
		try {

	        // p^[ݒ
			m_FvxCorrelation->SetPattern( m_FvxPattern );
			// T[`s
			m_FvxCorrelation->Execute( m_FvxImage1, &lngCount );

		} catch( _com_error ) {

			m_FvxCorrelation->GetErrReport( &lngErr );
		}

		if  ( lngErr == 0  ) {
			// ͈͂ŕ\
            m_disp->m_FvxDisplayEx->PutPenColor( RGB(128, 128, 255) );
            m_disp->m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
            
            // T[`ʂԂŕ\
			m_disp->m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );

			IFvSearchResultPtr pSearchResult( __uuidof( FvSearchResult ));			// O[T[`̌
			IFvRectangle2Ptr pInpRect( __uuidof( FvRectangle));						// Qlvs̈iACg̍Wj
			IFvBlobResultGroup3Ptr pBlobResultGroup( __uuidof( FvBlobResultGroup));	// Qlv

			if ( lngCount > 0 ) {
                m_FvxCorrelation->GetResult( 0, pSearchResult );
                m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult );
                
                // ʒũYʂZo
                double dblDiffX = pSearchResult->Getx() - m_pStandardPoint->Getx();
                double dblDiffY = pSearchResult->Gety() - m_pStandardPoint->Gety();
                
				//Qlv͈͂ړ
                pInpRect->Putxs( m_pBlobExeRect->Getxs() + dblDiffX );
                pInpRect->Putys( m_pBlobExeRect->Getys() + dblDiffY );
                pInpRect->Putxe( m_pBlobExeRect->Getxe() + dblDiffX );
                pInpRect->Putye( m_pBlobExeRect->Getye() + dblDiffY );
                m_FvxBlob->SetInspectArea( pInpRect );
                m_disp->m_FvxDisplayEx->DrawData( 0, pInpRect );	// v͈͂̕\
        
                // QlApplyChanges̒ŎsĂ
                m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage2 );
                
                // Qlvs
                try {
					m_FvxBlob->Execute( m_FvxImage2, &lngCount );
				} catch( _com_error ) {
					m_FvxBlob->GetErrReport( &lngErr );
				}
					
                if ( lngErr == 0  ) {
                    m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
                    m_FvxBlob->GetResult( 0, pBlobResultGroup );
                    m_disp->m_FvxDisplayEx->DrawData( 0, pBlobResultGroup );	// dS_ƊOڒ``
                    
                    cResult.Format("Yw : %.2f\r\nYx : %.2f\r\n\r\nou[u : %d\r\n", dblDiffX , dblDiffY , lngCount);
				
				} else {
				
					CString cStr ;
					CString cTemp ;

					switch ( lngErr ) {
						case 0:
							cStr = "G[";
						case 3001:
							cStr = "C[WIuWFNgNULLw肳Ă܂B";
						case 3005:
							cStr = "p[^Ⴂ܂B";
						case 3006:
							cStr = "̌^Ⴂ܂B";
						case 3007:
							cStr = "NULLw肳Ă܂B";
						case 3010:
							cStr = "̊mۂɎs܂B";
						case 3012:
							cStr = "u[u܂";
						case 3014:
							cStr = "u[u܂";
						default:
							cStr = "sȃG[";
						}
						cTemp.Format(" %d", lngErr);
						MessageBox(cStr + cTemp , "QlvG[", MB_ICONWARNING | MB_OK);
				}
			} else {
				MessageBox("T[`p^܂ł" , "G[", MB_ICONWARNING | MB_OK);
			}
		} else {

			CString cStr ;
			CString cTemp ;

			switch ( lngErr ) {
				case 0:
					cStr = "G[";
				case 5001:
					cStr = "p^݂Ă܂B";
				case 5005:
					cStr = "p[^Ⴂ܂B";
				case 5006:
					cStr = "^Ⴂ܂B";
				case 5007:
					cStr = "p^摜̂߁Ao^ł܂B";
				case 5008:
					cStr = "p^ƃ}XÑTCYvĂ܂B";
				case 5009:
					cStr = "p[^NULLlw肳܂B";
				case 5010:
					cStr = "̊mۂɎs܂B";
				case 5022:
					cStr = "p^w肳Ă܂B";
				default:
					cStr = "sȃG[";
				}
			cTemp.Format(" %d", lngErr);
			MessageBox(cStr + cTemp , "OCT[`G[", MB_ICONWARNING | MB_OK);
		}
			   
        // ------------------------------------------------------------
        // ԑI
        double dblTime = 0;
		m_FvxPerformanceCounter->StopCount( &dblTime );
        m_result.Format(": %.2fms\r\n\r\n",dblTime );
		m_result = m_result + cResult;
		UpdateData(FALSE);

	}
}

// Tvs
void CGSBlobDlg::OnDosample() 
{

	long lngErr = 0;
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CString sFilePath = szIniFilePath;
	sFilePath.Replace("GSBlob.exe","sample1.bmp");

    // }X^摜ǂݍ
	try {
		m_FvxFileAccess->PutFilePath( _bstr_t(sFilePath) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch(_com_error){
	
		m_FvxFileAccess->GetErrReport( &lngErr );
		if ( lngErr != 0  ) {
			MessageBox("sample1.bmpǂݍ߂܂ł" , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
		
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("}X^摜ǂݍ" , "G[", MB_ICONWARNING | MB_OK);
    
    // p^ǂݍ
	sFilePath.Replace("sample1.bmp","sample1.pat");
    
	try {	
		m_FvxPattern->PutLoadPattrenFileName ( _bstr_t(sFilePath));
		m_FvxPattern->Load();
	} catch( _com_error ) {
		m_FvxPattern->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample.patǂݍ߂܂ł" , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
    
    // Qlv͈͐ݒ
    m_pBlobExeRect->Putxs( 120 );
    m_pBlobExeRect->Putys( 270 );
    m_pBlobExeRect->Putxe( 250 );
    m_pBlobExeRect->Putye( 303 );
    
    // ʒu
	CGSBlobDlg::OnSetstandard();
	MessageBox("p^ݒ聕Qlv̈ݒ聕" , "", MB_ICONWARNING | MB_OK);
    
    // 摜ǂݍ
	sFilePath.Replace("sample1.pat","sample2.bmp");
	try {
		m_FvxFileAccess->PutFilePath( _bstr_t( sFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch ( _com_error ) {
		m_FvxFileAccess->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample2.bmpǂݍ߂܂ł" , "", MB_ICONWARNING | MB_OK);
			return;
		}
	}
    
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("摜ǂݍ" , "", MB_ICONWARNING | MB_OK);
    
    // s
    CGSBlobDlg::OnExecute();
	MessageBox("ACgQlvs" , "", MB_ICONWARNING | MB_OK);
	
}
